/**
 * Copyright (c) 2015 Impact Mobile Inc.
 */
package com.test;

import java.util.concurrent.atomic.AtomicInteger;

import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.jms.Message;
import javax.jms.MessageListener;

@MessageDriven( name = "Consumer", messageListenerInterface = MessageListener.class, activationConfig = {
        @ActivationConfigProperty( propertyName = "acknowledgeMode", propertyValue = "Auto-acknowledge" ),
        @ActivationConfigProperty( propertyName = "destinationType", propertyValue = "javax.jms.Queue" ),
        @ActivationConfigProperty( propertyName = "destination", propertyValue = Consumer.QUEUE ),
        @ActivationConfigProperty( propertyName = "maxSession", propertyValue = "20" ) })
public class Consumer implements MessageListener
{
    public static final String QUEUE = "hornetq-test.test-queue";
    public static final String QUEUE_JNDI = "java:jboss/queue/" + QUEUE;

    private static AtomicInteger processed = new AtomicInteger();

    @Override
    public void onMessage( Message message )
    {
        try
        {
            Thread.sleep( Integer.getInteger( "hornetq-clustering.thread.sleep", 0 ) );
        }
        catch ( InterruptedException e )
        {
        }
        processed.incrementAndGet();

    }

    public static int getProcessed()
    {
        return processed.getAndSet( 0 );
    }

}
